;
; c64mp3 decoder and demo
;
;by Pex 'Mahoney' Tufvesson, February 2010.
;Released at Datastorm 2010. http://www.datastorm.se
;
;If you want to encode another song, please look through
;the encoder folder first. The data from the song is
;in the files named SID*.s in this (the decoder) folder.
;
;There are make files, not very complete ones, but they
;do the trick for me.
;
;The whole thing, decoder and demo, is included in the
;files main.s, 2x2_charset and man_with_hat_inv.bin.
;
;on Linux:  make run
;on Win32:  rename makefile_win to makefile, then nmake.exe run
;
;The resulting Commodore 64 executable is in the file
;c64mp3.prg
;
;Sorry for not making the source code easy to follow.
;And, the coding is a mess, which it has to be to be able to
;do the things it does.
;But, I never said it would be easy! ;)
;
;
; Good luck...! You'll need it! :-D
;
;
;Have a noise night!
;
;/ Pex 'Mahoney' Tufvesson
;http://mahoney.c64.org
;http://www.livet.se/visa
;



; Funny macro to translate ISO8859-1 ASCII to C64 screen codes:

.macro _SCREEN arg1
  .if (arg1<'A')
    .byte 0+arg1
  .elseif (arg1<('Z'+1))
    .byte (arg1-$20)
  .elseif (arg1<'a')
    .byte 0+arg1
  .elseif (arg1<('z'+1))
    .byte (arg1-$60)
  .else
    .byte 0+arg1
  .endif
.endmacro

.macro SCREEN Arg
  .repeat .strlen(Arg), i

  .if (.strat(Arg,i)<'A')
          .byte 0+.strat(Arg,i)
  .else
    .if (.strat(Arg,i)<('Z'+1))
          .byte (.strat(Arg,i)-$00)
    .else
    .if (.strat(Arg,i)<'a')
          .byte 0+.strat(Arg,i)
    .else
      .if (.strat(Arg,i)<('z'+1))
          .byte (.strat(Arg,i)-$60)
      .else
          .byte 0+.strat(Arg,i)
      .endif
    .endif
    .endif
  .endif
  .endrepeat
.endmacro 

lyricsScreen = $1f;
thisWave3 = $20
thisWave2 = $21
lyricsWait = $22;
screenPoi = $23; Two-byte pointer
lyricsPoi = $25; Two-byte pointer
ticksToTrig = $27
SaveA = $28
SaveX = $29
SaveY = $2a
interpolValue = $2b
thisWave = $2d
nextWave = $2e
countLSB = $2f
thisVolume = $31
;nextVolume = $32  ;This is currently not used
spriteWait = $32
oldWave = $33  ;For noise playing
ticksToWait = $34
SIDenc3SpeedPoi = $35 ;Two-byte pointer
currentSpeed = $37
doingHighNybble = $38
nofWaveRepeats = $39
SIDencWavePoi = $3a ;Two-byte pointer
noisePoi = $3c; Two-byte pointer

;---------------------------------------------------------------------------
  .org $0256         ;Two bytes earlier to make room for loading address.
  .word $0258        ;Loading address
;  sei         ;done already in the pucrunch depack routine
;  lda #$35    ;-"-
;  sta $01
  ldx #$ff
  txs
  lda #$80   ;Fill the sound buffer with silence
  ldx #$c0
moreZeros:
  pha
  dex
  bne moreZeros
  lda #$00
  sta $d020
  sta $d021
  lda #$d8
  sta $d018
  lda $DD00
  and #%11111100
;  ora #%00000000 ;choose $c000-$ffff bank3
  sta $DD00
  jsr nmiInit
  jsr playNoiseInit
  jsr makeVolumeTable
;$D018 = %xxxx100x -> charmem is at $2000
;$D018 = %1111xxxx -> screenmem is at $3c00 = $fc00
  ;uppermost bit in color mem turns on multicolor
  ldx #00
  lda #$02+8
clrCol: 
  sta $d800,x
  sta $d900,x
  sta $da00,x
  sta $db00,x
  dex
  bne clrCol
  lda #$0a
  sta $d022
  lda #$01
  sta $d023
  lda #$d8   ;multicolor mode on
  sta $d016
  jsr initLyrics
  jsr initWave  ;init counter for decoding SIDencWave
  jsr initSpeed ;init counter for decoding SIDenc3Speed
  jsr nmiStart
;  jsr initSprite  ;Yes, we could have 1 sprite, but there's not enough
;                    ;clock cycles to display it :-( Maybe if I had some
;                    ;more hours to code I would find them... :-D
  jmp letsGo


;-----------------------------------------------------------------------------
; NMI Sample player with 8-bit output
; Loads of scary stuff going on here. Mind the gap.
;-------------------------------------------------------------------------

; ---------------------------------------------------------------------------
;This piece of code is moved into ZeroPage to make
;execution faster.

;Replay routine _with_ pitch playing a 51 byte long waveform located
;at $8000-$b300. One byte at every page. There are 256 waveforms.
;No more, no less.
;  Waveform 0 will have its bytes at $b300 (byte no# 0)
;                                    $b200 (byte no# 1)
;                                    $b100 (byte no# 2)
;                                    $8000 (byte no#51)
;  Waveform 1 will have its bytes at $b301 (byte no# 0)
;Waveform 255 will have its bytes at $b3ff (byte no# 0)

; This means that we have a total of 256*51/7812.5 = 1.671168 seconds
; of sample memory. This playroutine is capable of playing "lossless audio"
; for 1.67 seconds.
; Could extract "breathing" as a short sample, for instance.

; Pitching can be done from 100% speed
; up to 1.0 + 50/51 * 255/256 = 197.7% speed. (Not 200% since we don't do extra skip when wrapping to another
; waveform). nextSpeed:   0 = 100%
;                       255 = 197.7%

;By changing 2 bytes in the ZeroCode (DEC Poi+2  -> inc Poi+2), we could use memory
;$e000-$ffff for waveforms as well, but these waveforms will only be
;32 bytes long. They could be used for "no pitch samples", which would
;give us another 32*256 / 7812.5 = 1.05 seconds of waveform memory.
; But, this needs really good timing for switching the direction
; of pointers. OR - we'll implement a second replayroutine for these
; alone.

; We could save a couple of clock cycles by "double buffering" the
; replay routine. Then, the upcoming values for speed, waveform, and
; "next kind of sound" could be written well in advance into the unused replay
; routine.

ZeroCodeStart:
ZeroCode:
NMI_R1:
  lda #$11   ;output current value
  sta $d404
;  sta $d020  ;visualize it on screen
  lda #9     ;test bit = reset oscillator counter
  sta $d404
;  sta $d020  ;visualize it on screen
Poi_R1:
  lda $01ff
  sta $d401  ;set increment speed for next value            
;  sta $d020  ;visualize it on screen
  lda #1     ;start counting
  sta $d404
;  sta $d020  ;visualize it on screen
;  sta $d000  ;For making a waveform motion in a sprite
  ;dec     Poi_R1+1-ZeroCodeStart+ZeroCodeDest
  .byte $C6    ;DEC ZP
  .byte Poi_R1+1-ZeroCodeStart+ZeroCodeDest
SaveAnmi_R1:
  lda #0
  jmp $dd0c  ;Synchronous Serial I/O Data Buffer - will "read" DD0D
                  ;Which will clear pending NMI IRQ.
                  ;LDA $dd0d takes 4 cycles
                  ;JMP $dd0c takes 3 cycles




ZeroCodeEnd:

ZeroCodeDest = $40;
;-------------------------------------

nmiInit:
  ldx #ZeroCodeEnd-ZeroCode
moveMore:
  lda ZeroCode,x
  sta ZeroCodeDest,x
  dex
  bpl moveMore
  ldx #$18
  lda #0
clrLoop:
  sta $d400,X
  dex
  bpl clrLoop
  lda #$4f ;High pass filter
  sta $d418
  lda #$f0 ;Max sustain level
  sta $d406
  rts


nmiStart:
  lda #0     ;No Sprites
  sta $d015  ;Sprite display Enable: 1 = Enable
  lda #$7F   ;Set NMI mask to 0 for all NMIs
  sta $dc0d  ;CIA Interrupt Control Register (Read NMls/Write Mask)
  lda $dc0d  ;Clear all pending NMI flags
  lda #$40   ;Store an "RTI" opcode in $DD0C so we can
             ;jump to $DD0C and trigger a "read" of byte $DD0D
             ;"for free". Doing an rti will make a read of
             ;$DD0D, but ignore the value read.
             ;Reading $DD0D will clear any pending NMI IRQs.
  sta $dd0c  ;Synchronous Serial I/O Data Buffer
  lda #$4C   ;The "JMP" opcode
  sta $dc04  ;Timer A: Low-Byte
  lda #0     ;The LOW-byte of where the NMI will jump to
  sta $dc05  ;Timer A: High-Byte
  lda #$10   ;Force load Timer A, system02clk, continuous, stop
  sta $dc0e  ;CIA Control Register A
  lda #$3E   ;62 ticks   = The HIGH-byte of where the NMI will jump to
  sta $dc06  ;Timer B: Low-Byte
  lda #0
  sta $dc07  ;Timer B: High-Byte
  lda #0
  sta $dd05  ;Timer A: High-Byte
  lda #$11   ;Force load Timer A, continuous, start
  sta $dd0e  ;CIA Control Register A
  jsr syncCPUtoScreenOhYes
  lda #<FirstNMI
  sta $fffa       ;NMI low-byte
  lda #>FirstNMI
  sta $fffb       ;NMI high-byte
  lda #$10
  sta $dd04  ;Timer A: Low-Byte
  lda #$11   ;Force load Timer B, continuous, start
  sta $dc0f  ;CIA Control Register B
  sta $dd0e  ;CIA Control Register A

  lda $dd0d  ;CIA Interrupt Control Register (Read NMls/Write Mask)
  lda #$81
  sta $dd0d  ;CIA Interrupt Control Register (Read NMls/Write Mask)
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  jmp syncIt


syncIt:
  jsr syncCPUtoScreenOhYes
  lda #4
  sta $fffa  ;NMI
  lda #$dc
  sta $fffb  ;NMI
  lda #$7d
  sta $dd04  ;Timer A: Low-Byte
  ldx #$0f
loopIt:
  dex
  bne loopIt
  ldx #$11
  stx $dd0e  ;CIA Control Register A
  bne inTheMiddle+1
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
inTheMiddle:
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$c9
  cmp #$24 ;  $24 $ea is a "BIT $EA" opcode
  nop
  lda SaveAnmi_R1-ZeroCodeStart+ZeroCodeDest+1  ;Magically written number from TimerB
  cmp #$11
  bne wasteACycle
wasteACycle:
  stx $dc0f  ;CIA Control Register B
  lda $dd0d  ;CIA Interrupt Control Register (Read NMls/Write Mask)
  lda #$81
  sta $dd0d  ;CIA Interrupt Control Register (Read NMls/Write Mask)
  lda #<IRQ
  sta $fffe  ;IRQ low
  lda #>IRQ
  sta $ffff  ;IRQ high
  lda #1
  sta $d01a  ;IRQ Mask Register: 1 = Interrupt Enabled
  lda #$80
  sta $d012  ;Read Raster / Write Raster Value for Compare IRQ
  lda #$1b
  sta $d011  ;VIC Control Register
  cli
  rts


syncCPUtoScreenOhYes:
  php
  sei
  lda #$ff
simpleWaitLoop:
  cmp $d012
  bne simpleWaitLoop
  ldy $d012
  iny
  ldx #$0a
simpleWaitLoop2:
  dex
  bne simpleWaitLoop2
  ldx #$20
anotherOnePlis:
  jsr justAnRts
  jsr justAnRts
  jsr justAnRts
  nop
  inc $d013
  dec $d013
  cpy $d012
  beq wasteALittle
wasteALittle:
  iny
  dex
  bne anotherOnePlis
  plp
justAnRts:
  rts

FirstNMI:
  pha
  lda #$7f  ;Clear NMI mask
  sta $dd0d ;CIA Interrupt Control Register (Read NMls/Write Mask)
  lda $dd0d ;Ack all NMI IRQs
  lda $dc06 ;Timer B: Low-Byte
  sta SaveAnmi_R1-ZeroCodeStart+ZeroCodeDest+1   ;Magically change accumulator with value in TimerB
  pla
  rti

;-----------------------------------

playNoiseInit:
  lda #$22
  sta $d413 ;SID voice3 attack speed = 2, decay speed = 2
            ;This is to make sure that we don't trigger
            ;the ADSR-bug. Otherwise, if we want to change
            ;attack/decay/release speed, make sure to
            ;change "the one that isn't used":
            ;   change attack/decay speed when bit0 in $d404 is = 0.
            ;   change release speed when bit0 in $d404 = 1
  lda #230  ;Max frequency of noise clocking, could be changed if we
  sta $d40e ;want to use the -15dB notch-filter-like dip that is present
  sta $d40f ;in the passband. freq $ffff -> notch at 10kHz.
  ldx #255  ;something else for voice 2, this is the "dithering noise"
  stx $d407
  stx $d408
  stx thisWave2 ;Silent waveforms
  stx thisWave3
  inx
  stx oldWave
  lda #$10
  sta $d40d ;Sustain level for voice 2, "dithering noise"
  lda #1    ;Trig ADS-cycle for dithering noise, to ensure that we get to the
            ;sustain level directly
  sta $d40b
  lda #<encodedNoise
  sta noisePoi
  lda #>encodedNoise
  sta noisePoi+1
  lda #3
  sta ticksToWait
  lda #128
  sta ticksToTrig
  lda #$06   ;No resonance, filter on voice 2+3
  sta $d417
  lda #$4f   ;High pass filter, max volume
  sta $d418
  lda #$b0   ;Cutoff
  sta $d415
  sta $d416
doRts:
  rts

;  SCREEN "i love melina"

;ToDo: d416 as well...
playNoise:
  dec ticksToTrig
  bne noTrigg
  lda oldWave
  cmp #$80
  bne noTrigg
  lda #$01
  sta $d412
  sta oldWave
noTrigg:  
  dec ticksToWait
  bne doRts
where:
  beq off  ;We're starting with off...
on:
  lda #$81  ;Yes, it's time for noise!
  sta $d412
  sta oldWave
  ldy #0
  lda (noisePoi),y
  sta ticksToWait   ;How long will this noise be?
  bne notQuit
                 ;We're all done, let's go home
  lda #96        ;=rts
  sta playNoise  ;self modify start of playNoise routine.
notQuit:
  inc noisePoi
  bne noWrr
  inc noisePoi+1
noWrr:
  lda #off-where-2  ;next time, let "where:" jump to off
  sta where+1
  rts
off:
  lda oldWave
  cmp #$81
  bne noSilen
  lda #$80  ;shut up!
  sta $d412
  sta oldWave
noSilen:  
  ldy #0
  lda (noisePoi),y
  sta ticksToWait    ;How long will this silence be?
  tax
  lda #4
  sta ticksToTrig
  inc noisePoi
  bne noWrr2
  inc noisePoi+1
noWrr2:
  lda (noisePoi),y
  sta $d414   ;Set sustain level for next noise
  inc noisePoi
  bne noWrr3
  inc noisePoi+1
noWrr3:
  txa         ;If ticksToWait = 0, don't make any sound
  beq dooRts
  lda #on-where-2  ;next time, let "where:" jump to on
  sta where+1
dooRts:
  rts




;----------------------------------

; Now it's time to run-length encode these.
; Encode them as:
; SIDwave:
; Byte even: number of repeats
; Byte odd:  value

initWave:
  lda #0
  sta nofWaveRepeats
  lda #<SIDencWave
  sta SIDencWavePoi
  lda #>SIDencWave
  sta SIDencWavePoi+1
  lda #$ff
  sta thisWave
  sta nextWave
  lda #$10
  sta interpolValue
  rts


interpolSpeeds:
  .byte 255/1  ;nofSame=1
  .byte 256/2  ;nofSame=2
  .byte 256/3  ;nofSame=3
  .byte 256/4  ;nofSame=4
  .byte 256/5  ;nofSame=5
  .byte 256/6  ;nofSame=6
  .byte 256/7  ;nofSame=7
  .byte 256/8  ;nofSame=8
  .byte 256/9  ;nofSame=9
  .byte 256/10 ;nofSame=10
  .byte 256/11 ;nofSame=11
  .byte 256/12 ;nofSame=12
  .byte 256/13 ;nofSame=13
  .byte 256/14 ;nofSame=14
  .byte 256/15 ;nofSame=15
  .byte 256/16 ;nofSame=16



;-----------------------------

; SIDspeed:
; If SIDwave=255, skip it. (set to 255 directly)
; SIDencSpeed could be reasonably cheap encoded by encoding
; "differences" from -7 to +7 with one nybble.
; If nybble = -8 = 8, then grab next byte (may be split in 
; two separate nybbles), and put that into Speed value.
; First byte is the start speed.

initSpeed:
  lda #1
  sta doingHighNybble
  lda #<SIDenc3Speed
  sta SIDenc3SpeedPoi
  lda #>SIDenc3Speed
  sta SIDenc3SpeedPoi+1
  lda SIDenc3Speed
  sta currentSpeed
  rts





makeVolumeTable:
; Yes, I know this is slow and could be done faster.
; But, it doesn't matter, does it? :-D
;  lda #$11
;  sta moreAmp+1 ;Desired volume
  lda #$80
  ldx moreAmp+1
  jsr MULT8
  sta ZeroRef
  ldy #0
moreAmp:
  ldx #$0f   ;The desired volume for volume table #0
  tya
  jsr MULT8
  lda PROD+1
  sec
  sbc ZeroRef
  clc
  adc #$80
ampDest:
  sta volumeTable,y
  iny
  bne moreAmp
  lda moreAmp+1
  clc
  adc #$10      ;The desired volume increase for next table
  sta moreAmp+1
  lda ampDest+2
  clc
  adc #1
  sta ampDest+2
  cmp #>volumeTable+16
  bne makeVolumeTable
  rts

ZeroRef: .byte 0
PROD: .byte 0,0
MPR: .byte 0
MPD: .byte 0,0
;-------------------------------------------------------
; MULTIPLY ROUTINE 8x8=>16 unsigned
; Accumulator*X -> [PRODL,PRODH] (low,hi) 16 bit result
MULT8:
  sta MPR
  stx MPD
  clc
  lda #0
  sta MPD+1
  sta PROD
  sta PROD+1

  ldx #8
LOOPMUL:
  lsr MPR
  bcc NOADD
  clc
  lda PROD
  adc MPD
  sta PROD
  lda PROD+1
  adc MPD+1
  sta PROD+1
NOADD:
  asl MPD
  rol MPD+1
  dex
  bne LOOPMUL
  rts



idleColor:
  lda #0
  sta $d020
  tsx
;  clc
;Now choose "how far ahead" we should be when calculating the next
;values. This also determines how many stack values we want to be able
;to use in our mainLoop/IRQs.
;  adc #$90  ;$60 is ok, $10 is ok, $02 is notOk, $f0 is notOk
Ever:
;  cpx Poi_R1+1-ZeroCodeStart+ZeroCodeDest   ;This assembles into a non-zero page decrement. Need to hard code it to make it proper.
  .byte $e4        ;CPX ZP
  .byte Poi_R1+1-ZeroCodeStart+ZeroCodeDest
  bpl Ever  ;Nothing to do here, we're 128-255 bytes "off"
  lda #2
  sta $d020
  jmp doNextOneDirectly

letsGo:
; Always have 128 bytes "buffer" in the stack for playing

nextOnePlease:
  tsx
;  cpx Poi_R1+1-ZeroCodeStart+ZeroCodeDest   ;This assembles into a non-zero page decrement. Need to hard code it to make it proper.
  .byte $e4        ;CPX ZP
  .byte Poi_R1+1-ZeroCodeStart+ZeroCodeDest
  bpl idleColor   ;2 clocks, 3 if taken, 4 if into another page

doNextOneDirectly:
;Ok, we need to fill the stack with a maximum of ~$70 bytes data.
;We can take our time, there's plenty of clocks before they are needed!
; We cannot, however, use subroutines inside the renderLoop.
; The stack pointer needs to be clean! But, who would do that anyway?
  jsr playNoise
  
;  jsr playNoise2  ;Save some clock cycles by inlining this function:
;playNoise2:
  ldx #$1
  ldy thisWave3
;  lda thisWave3
;  cmp #$ff
  iny
  beq yepSilent
  ldx #$81
yepSilent:
  stx $d40b
  lda thisWave2
  sta thisWave3
  lda thisWave
  sta thisWave2

;Inlined this function:
getNextWave:    
  dec nofWaveRepeats
  bpl dontChangeWave
  ldy #0
  lda (SIDencWavePoi),y
  tax
;  lsr
;  lsr
;  lsr
;  lsr
  lda theLsrTable,x  ;4 clocks instead of the 8 above...
  sta thisVolume
  txa
  and #$0f
  sta nofWaveRepeats
  tax
  lda interpolSpeeds,x
  sta interpolSpeed+1

  inc SIDencWavePoi
  bne noWrWa
  inc SIDencWavePoi+1
noWrWa:
  lda (SIDencWavePoi),y
  sta thisWave
  inc SIDencWavePoi
  bne noWrWa2
  inc SIDencWavePoi+1
noWrWa2:
;  lda (SIDencWavePoi),y ;Time to look ahead - what's up doc?
;  lsr
;  lsr
;  lsr
;  lsr
;  sta nextVolume ;This is currently not used. Would be nice for interpolating volume level as well.
  iny
  lda (SIDencWavePoi),y
  sta nextWave
  jmp contAfterGetNextWave
dontChangeWave:

  lda interpolValue
  clc
interpolSpeed:
  adc #0
  sta interpolValue
;  rts

contAfterGetNextWave:  


;  jsr getNextSpeed
getNextSpeed:      ;inlined this fuction to save CPU cycles
  lda thisWave
  cmp #$ff
  bne noSilence
;  lda #$ff          ;it is #$ff already...
  sta currentSpeed
  jmp contAfterGetNextSpeed

noSilence:
  ldy #0
  lda doingHighNybble
  beq doLow
  lda (SIDenc3SpeedPoi),y
;  lsr
;  lsr
;  lsr
;  lsr
  tax
  lda theLsrTable,x  ;6 clocks instead of the 8 above...
  cmp #$8
  beq grabNext2Nybbles
  bcs doSub
  clc
  adc currentSpeed
  sta currentSpeed
  sty doingHighNybble ;Next time, grab the low nybble
  jmp contAfterGetNextSpeed

doSub:
  ora #$f0
  clc
  adc currentSpeed
  sta currentSpeed
  sty doingHighNybble ;Next time, grab the low nybble
  jmp contAfterGetNextSpeed

grabNext2Nybbles:
  lda (SIDenc3SpeedPoi),y
  asl
  asl
  asl
  asl
  sta currentSpeed
  inc SIDenc3SpeedPoi
  bne noWam
  inc SIDenc3SpeedPoi+1
noWam:
  lda (SIDenc3SpeedPoi),y
;  lsr
;  lsr
;  lsr
;  lsr
  tax
  lda theLsrTable,x  ;6 clocks instead of the 8 above...
  ora currentSpeed
  sta currentSpeed
  sty doingHighNybble ;Next time, grab the low nybble
  jmp contAfterGetNextSpeed

doLow:
  lda (SIDenc3SpeedPoi),y
  and #$f
  cmp #$8
  beq grabNext2Nybbles2
  bcs doSub2
  clc
  adc currentSpeed
  sta currentSpeed
  inc SIDenc3SpeedPoi
  bne noWam3
  inc SIDenc3SpeedPoi+1
noWam3:
  inc doingHighNybble ;Next time, grab the high nybble
  jmp contAfterGetNextSpeed

doSub2:
  ora #$f0
  clc
  adc currentSpeed
  sta currentSpeed
  inc SIDenc3SpeedPoi
  bne noWam5
  inc SIDenc3SpeedPoi+1
noWam5:
  inc doingHighNybble ;Next time, grab the high nybble
  jmp contAfterGetNextSpeed

grabNext2Nybbles2:
  inc SIDenc3SpeedPoi
  bne noWam2
  inc SIDenc3SpeedPoi+1
noWam2:
  lda (SIDenc3SpeedPoi),y
  sta currentSpeed
  inc SIDenc3SpeedPoi
  bne noWam4
  inc SIDenc3SpeedPoi+1
noWam4:
  inc doingHighNybble ;Next time, grab the high nybble
;  jmp contAfterGetNextSpeed






contAfterGetNextSpeed:
  sta speedLSB_RL+1


  lda thisWave
  cmp #$ff
  bne notOnlyInsertSilence
  sta currentSpeed    ;it's $ff already
  lda #$80
  pha
  pha
  pha
  pha
  pha
  pha
  pha
  pha
  pha
  pha
  pha
  pha
  pha
  pha
  pha
  pha
  pha
  pha
  pha
  pha
  pha
  pha
  pha
  pha
  pha
  pha
  jmp nextOnePlease

notOnlyInsertSilence:
;  lda #0

;Interpol values:
;bit7: 1=use prevWave, 0=use nextWave
;bit4: 1=use maxVol for thisWave
;bit3-0: Volume to use for thisWave. 15-value = volume for other wave
;Now modify the replay routine with the above in mind.

  ldx thisWave
  lda SIDwaveformPoiTableMSB,x
  sta Poi_RL2+2
  lda SIDwaveformPoiTableLSB,x
  sta Poi_RL2+1
  ldx nextWave
;Insert into RL1 of RenderLoop
  lda SIDwaveformPoiTableMSB,x
  sta Poi_RL1+2
  lda SIDwaveformPoiTableLSB,x
  sta Poi_RL1+1

;Set the volume for RL2 (thisWave)
  lda interpolValue
;  lsr
;  lsr
;  lsr
;  lsr
  tax
  lda theLsrTable,x  ;6 clocks instead of the 8 above...
;  clc
;  adc #>volumeTable
  ora #>volumeTable  ;ok as long as volumetable starts on even 4kB address
  sta volPoi_RL2+2
;x and y are constants for setting RL1 sounding or silent.
  ldx #$80
  ldy #$79    ;= ADC Absolute.Y
;  lda interpolValue
;  lsr
;  lsr
;  lsr
;  lsr
  and #$0f ;2 clocks instead of the 4+8 above
  eor #$0f
  sec
  sbc #1
  bpl notSilent
;Make RL1 silent:
  ldx #0
  ldy #$b9    ;= lda Absolute,Y
notSilent:
  stx zeroLevelAdjust+1
  sty volPoi_RL2   ;Self modify the opcode for second addition
;Set the volume for RL1 (prevWave/nextWave)
;  clc
;  adc #>volumeTable
  ora #>volumeTable  ;ok as long as volumetable starts on even 4kB address
  sta volPoi_RL1+2

;ToDo:
; Interpolate prevVolume/thisVolume/nextVolume as well...
  lda thisVolume
;  clc
;  adc #>volumeTable
  ora #>volumeTable  ;ok as long as volumetable starts on even 4kB address
;  lda #$cf           ;Max volume always for output. Fun but irritating.
  sta volPoi_RL+2

; The any+any loop:
nextX:
  ldx #$32
RenderLoop:
Poi_RL1:
  ldy $8000,x                ;4 clocks, 5 if crossing page
volPoi_RL1:
  lda volumeTable+$0f00,y         ;4
;  clc                       ;2
Poi_RL2:
  ldy $8000,x                ;4 clocks, 5 if crossing page
volPoi_RL2:
  adc volumeTable+$0f00,y         ;4 clocks, 5 if crossing page
;  lda volumeTable+$0f00,y         ;4 clocks, 5 if crossing page
;  adc #$80                   ;2 clocks
zeroLevelAdjust:
  adc #$00                   ;2 clocks
  tay                        ;2 clocks
volPoi_RL:
  lda volumeTable+$0f00,y     ;4 clocks, 5 if crossing page
  pha                        ;3 clocks
;Now check if we should skip 1 or 2 bytes:
  lda countLSB               ;3 clocks (ZP)
;Ideally, we should have a sec here. But hey - it doesn't really
;         matter that much, does it? ;)
;  sec                        ;2 clocks
speedLSB_RL:
  sbc #0                     ;2 clocks
  sta countLSB               ;3 clocks (ZP)
  bcs noX                    ;2 if not taken, 3 if taken, 4 if taken into antother page
  dex                        ;2
noX:
  dex                        ;2
  bpl RenderLoop             ;2 if not taken, 3 if taken, 4 if taken into another page
  txa
  clc
  adc #waveLength
  sta nextX+1
  jmp nextOnePlease
;
;; This is a total of ~42 clocks per sample. This is good enough!
;; Can crossfade with these levels:
;; 0/16 + 16/16 (by self modifying the first adc in the loop to an lda instead, and doing an adc #$00 afterwards)
;; 1/16 + 15/16 (volumeTable #0 + #14)
;; 2/16 + 14/16              #1 + #13
;; 3/16 + 13/16              #2 + #12
;; 4/16 + 12/16              #3 + #11
;; 5/16 + 11/16              #4 + #10
;; 6/16 + 10/16              #5 + #9
;; 7/16 +  9/16              #6 + #8
;; 8/16 +  8/16              #7 + #7
;; Amplitude of waveforms = +-127
;; Waveforms need to be sequential, one waveform from $8033 downto $8000. Last sample at $8000



; Old renderLoop where waveforms were interleaved in memory,
; and read backwards
;RenderLoop:
;Poi_RL:
;  ldx $b4ff            ;4
;volPoi_RL:
;  lda volumeTable,x    ;4
;  pha                  ;3
;;Now check if we should increment and skip a byte:
;countLSB_RL:
;  lda #0               ;2
;;Ideally, we should have a sec here. But hey - it doesn't really
;;         matter that much, does it? ;)
;  sec                  ;2
;speedLSB_RL:
;  sbc #0               ;2
;  sta countLSB_RL+1    ;4
;  lda Poi_RL+2         ;4
;  sbc #1               ;2
;  sta Poi_RL+2         ;4
;  bmi RenderLoop       ;3
;
;;nof cycles = 34 cycles per sample
;
;wrap_R1:
;  lda Poi_RL+2
;  clc
;  adc #53
;  sta Poi_RL+2
;  jmp nextOnePlease

  

;------------------------------



;; Other versions of the RenderLoop:
;; The 33%+66% loop:
;nextX:
;  ldx #53
;RenderLoop:
;Poi_RL:
;  lda $b400,x                ;4 clocks, 5 if crossing page
;  lsr                        ;2
;;  clc                        ;2
;  adc $b434,x                ;4 clocks, 5 if crossing page
;  tay                        ;2 clocks
;  lda volumeTable,y          ;4 clocks, 5 if crossing page
;  pha                        ;3 clocks
;;Now check if we should skip 1 or 2 bytes:
;  lda countLSB               ;3 clocks (ZP)
;;Ideally, we should have a sec here. But hey - it doesn't really
;;         matter that much, does it? ;)
;;  sec                        ;2 clocks
;speedLSB_RL:
;  sbc #0                     ;2 clocks
;  sta countLSB               ;3 clocks (ZP)
;  bcc noX                    ;2 if not taken, 3 if taken, 4 if taken into antother page
;  dex                        ;2
;noX:
;  dex                        ;2
;  bpl RenderLoop             ;2 if not taken, 3 if taken, 4 if taken into another page
;  txa
;  clc
;  adc #53
;  sta nextX+1
;
;; This is a total of ~36 clocks per sample. This is good enough.
;; Need to have the amplitude of the waveforms < 2/3 * 255 = 170
;; Signed, this is from -84 to +84. 84*1.5 = 126
;; The volumeTables can add a little distortion without trouble.




;; Other versions of the RenderLoop:
;; The any+any loop:
;nextX:
;  ldx #53
;RenderLoop:
;Poi_RL:
;  ldy $b400,x                ;4 clocks, 5 if crossing page
;  lda volumeTableA,y         ;4
;;  clc                       ;2
;  ldy $b434,x                ;4 clocks, 5 if crossing page
;  adc volumeTableB,y         ;4 clocks, 5 if crossing page
;  adc #$80                   ;2 clocks
;  tay                        ;2 clocks
;  lda volumeTableTotal,y     ;4 clocks, 5 if crossing page
;  pha                        ;3 clocks
;;Now check if we should skip 1 or 2 bytes:
;  lda countLSB               ;3 clocks (ZP)
;;Ideally, we should have a sec here. But hey - it doesn't really
;;         matter that much, does it? ;)
;;  sec                        ;2 clocks
;speedLSB_RL:
;  sbc #0                     ;2 clocks
;  sta countLSB               ;3 clocks (ZP)
;  bcc noX                    ;2 if not taken, 3 if taken, 4 if taken into antother page
;  dex                        ;2
;noX:
;  dex                        ;2
;  bpl RenderLoop             ;2 if not taken, 3 if taken, 4 if taken into another page
;  txa
;  clc
;  adc #53
;  sta nextX+1
;
;; This is a total of ~42 clocks per sample. This is good enough!
;; Can crossfade with these levels:
;; 0/16 + 16/16 (by self modifying the first adc in the loop to an lda instead.)
;; 1/16 + 15/16 (volumeTable #0 + #14)
;; 2/16 + 14/16              #1 + #13
;; 3/16 + 13/16              #2 + #12
;; 4/16 + 12/16              #3 + #11
;; 5/16 + 11/16              #4 + #10
;; 6/16 + 10/16              #5 + #9
;; 7/16 +  9/16              #6 + #8
;; 8/16 +  8/16              #7 + #7
;; Amplitude of waveforms = +-127
;; Waveforms need to be sequential, one waveform from $8033 downto $8000. Last sample at $8000


;We need a table of where waveforms are located in memory. This will
;occupy 512 bytes of memory.

;If waveforms are longer than 51 bytes, they _will_ eat up 2 additional clock cycles
;when read, since some of them will cross pages.


IRQEND:
  sta SaveA
  inc $d019 ;ack IRQ
  lda #$1b
  sta $d011
  lda #<IRQEND12
  sta $FFFE  ;IRQ low
  lda #>IRQEND12
  sta $FFFF  ;IRQ high
  lda #$02
  sta $d020
  lda #$5b
  sta $d012
  lda SaveA
  rti

IRQEND12:
  sta SaveA
  inc $d019 ;ack IRQ
;  lda #$1b
;  sta $d011
scrollx:  
  lda #$c8
  sta $d016
;$D018 = %xxxx111x -> charmem is at $3000 = $f800
;$D018 = %1101xxxx -> screenmem is at $3400 = $f400
  lda #$de
  sta $d018
  lda #<IRQEND3
  sta $FFFE  ;IRQ low
  lda #>IRQEND3
  sta $FFFF  ;IRQ high
  lda #$d0
  sta $d012
  lda SaveA
  rti


IRQEND3:
  sta SaveA
  inc $d019 ;ack IRQ
  lda #$1b
  sta $d011
  lda #$d8
  sta $d016
  lda #$c8
  sta $d018
;  lda #$03
;  sta $d020
  lda #<IRQEND2
  sta $FFFE  ;IRQ low
  lda #>IRQEND2
  sta $FFFF  ;IRQ high
  lda #$f8    ;Could be something between $f2 and $fa
  sta $d012
  lda SaveA
  rti

IRQEND2:
  sta SaveA
  inc $d019 ;ack IRQ
  lda #$13      ;Make sure that DEN (bit4) is 0 during raster line $30 - if we want to only display sprite0
  sta $d011
  lda #<IRQEND
  sta $FFFE  ;IRQ low
  lda #>IRQEND
  sta $FFFF  ;IRQ high
  lda #11 ;=49
  sta $d012
  sty SaveY
  jsr plotMan
  ldy SaveY
  lda SaveA
  rti

;The text is visible during unpacking, but only on "newer" C64s,
;they differ on what's in the color memory after reset.
  SCREEN "                                           "
  SCREEN "c64mp3 decoder by pex mahoney tufvesson "


;-----------------------------
  .RES $0800-*,$20
;  .org $0800
  sta SaveAnmi_R1-ZeroCodeStart+ZeroCodeDest+1        ;Zero page write
  jmp ZeroCodeDest    ;Waste no cycles
  nop ;waste 3 bytes to make this code appear at $0808:
  nop
  nop

plotMan:
;This is ugly and bad coding. But it does the trick. And that's what counts!
  lda #$60
  tax
  and #$7
  ora #$c8
  sta scrollx+1
  txa
  lsr
  lsr
  lsr

;Plot at row 5 = 6*40 = 240 = $f0
  clc
  adc #$f0
  sta wheere+1
  lda #>screen1
  adc #0  ;carry from above?
  sta wheere+2
  lda #$10
  sta ennd+1
  ldy #0
more:
  tya
wheere:
  sta $fc00,y
  iny
ennd:
  cpy #$10
  bne more
  lda ennd+1
  clc
  adc #$10
  sta ennd+1
  cmp #$d0
  beq finito
  lda wheere+1
  clc
  adc #$18
  sta wheere+1
  lda wheere+2
  adc #0
  sta wheere+2
  jmp more
finito:
manDir:
  inc plotMan+1
  lda plotMan+1
  bne noLeft
  ldy #$ee    ;inc absolute
  sty manDir
noLeft:
  cmp #$1a*8
  bne noright
  ldy #$ce    ;dec absolute
  sty manDir
noright:

;  lda $f000
;  bne invert
  rts
  
;Why is this code still here?
;nostalgic reasons ;)
;invert:
;  ldy #0
;invmore:  
;  lda $f000,y
;  eor #$ff
;  sta $f000,y
;  lda $f100,y
;  eor #$ff
;  sta $f100,y
;  lda $f200,y
;  eor #$ff
;  sta $f200,y
;  lda $f300,y
;  eor #$ff
;  sta $f300,y
;  lda $f400,y
;  eor #$ff
;  sta $f400,y
;  lda $f500,y
;  eor #$ff
;  sta $f500,y
;  lda $f600,y
;  eor #$ff
;  sta $f600,y
;  lda $f700,y
;  eor #$ff
;  sta $f700,y
;  iny
;  bne invmore
;  rts


  .RES $0900-*
;  .org $0900
; sta SaveAnmi_R1-ZeroCodeStart+ZeroCodeDest+1
  .byte $8d        ;STA 16-bit addr, Waste 1 cycle
  .byte SaveAnmi_R1-ZeroCodeStart+ZeroCodeDest+1
  .byte 0
  jmp ZeroCodeDest
  nop ;waste 2 bytes to make this code appear at $0908:
  nop

IRQ:
  sta SaveA
  inc $d019 ;ack IRQ
;  inc $d020
  lda #$1b
  sta $d011
  lda #<IRQ2
  sta $FFFE  ;IRQ low
;Slightly dangerous optimization: $ffff is already correct
;  lda #>IRQ2
;  sta $FFFF  ;IRQ high
  lda #$f8    ;Could be something between $f2 and $fa
  sta $d012
;  lda #82
;  sta $d001
  sty SaveY
  jsr doLyrics
;  jsr moveSprite  ;maybe next time...
  ldy SaveY
  lda SaveA
  rti

IRQ2:
  sta SaveA
  inc $d019 ;ack IRQ
;  dec $d020
  lda #$13      ;Make sure that DEN (bit4) is 0 during raster line $30 - if we want to only display sprite0
  sta $d011
  lda #<IRQ
  sta $FFFE  ;IRQ low
;Slightly dangerous optimization: $ffff is already correct
;  lda #>IRQ
;  sta $FFFF  ;IRQ high
  lda #11 ;=49
  sta $d012
;  lda #40
;  sta $d001
  lda SaveA
  rti

;initSprite:
;rts
;  lda #$01
;  sta $d015  ;sprite 7 on, the rest are off
;  sta $d010  ;MSB=1
;  lda #1
;  sta $d027  ;make it white
;;  sta $d017  ;expand Y
;  lda #$20     ;x-pos
;  sta $d000
;  lda #$ff    ;y-pos
;  sta $d001
;  lda #248    ;which sprite, we would like to place it at $fe00
;  sta $f3f8
;  sta $f7f8
;;  lda #0
;;  sta $3fff 
;;  lda #$0b
;;  sta $d021
;nothingToDo:
;  rts
;
;spriteBounce:
;  .byte $ff,$fd,$fc,$fb,$fa,$f9,$f9,$f8,$f7,$f7,$f6,$f6,$f6,$f5,$f5,$f5
;  .byte $f5,$f5,$f5,$f5,$f6,$f6,$f6,$f7,$f7,$f8,$f9,$f9,$fa,$fb,$fc,$fd
;
;moveSprite:
;  dec spriteWait
;  beq spriteSetY
;  bpl nothingToDo
;movS:
;  lda #4
;  sta spriteWait
;  inc $d000
;  bne noMSB
;  lda $d010
;  eor #$01
;  sta $d010
;noMSB:
;  rts
;
;spriteSetY:
;  lda $d000
;  and #$1f
;  tay
;  lda spriteBounce,y
;  sta $d001
;  rts


  .RES $0a00-*
;  .org $0a00
  sta SaveAnmi_R1-ZeroCodeStart+ZeroCodeDest+1
  nop                     ;Waste 2 cycles
  jmp ZeroCodeDest
  nop ;waste 2 bytes to make this code appear at $0a08:
  nop

  .RES $0b00-*
;  .org $0b00
  sta SaveAnmi_R1-ZeroCodeStart+ZeroCodeDest+1
  bit $ff             ;Waste 3 cycles
  jmp ZeroCodeDest
  nop ;waste a byte to make this code appear at $0b08:

  .RES $0c00-*
;  .org $0c00
  sta SaveAnmi_R1-ZeroCodeStart+ZeroCodeDest+1
  nop                    ;Waste 4 cycles
  nop
  jmp ZeroCodeDest
  nop ;waste a byte to make this code appear at $0c08:

  .RES $0d00-*
;  .org $0d00
  sta SaveAnmi_R1-ZeroCodeStart+ZeroCodeDest+1
  nop                    ;Waste 5 cycles
  bit $ff
  jmp ZeroCodeDest

  .RES $0e00-*
;  .org $0e00
  sta SaveAnmi_R1-ZeroCodeStart+ZeroCodeDest+1
  nop                   ;Waste 6 cycles
  nop
  nop
  jmp ZeroCodeDest

;-----------------------------------

SIDenc3Speed:
  .include "SIDenc3Speed.s"
SIDenc3SpeedEnd:

SIDencWave:
  .include "SIDencWave.s"
SIDencWaveEnd:

;Free space from ~7d00-7fff

  .RES $8000-*,$00
SIDwaveforms:
  .include "SIDwaveforms.s"
SIDwaveformsEnd:

  .RES $b500-*,$00
  .include "SIDwaveformPoiTable.s"

  .RES $b700-*,$00
encodedNoise:
  .include "SIDencodedNoise.s"   ;Approximately 1000 bytes
encodedNoiseEnd:

;Free space from ~bd00-bfff
initLyrics:
  lda #<Lyrics
  sta lyricsPoi
  lda #>Lyrics
  sta lyricsPoi+1
  lda #<screen1
  sta screenPoi
  lda #>screen1
  sta screenPoi+1
  lda #1
  sta lyricsWait
  lda #$d8
  sta lyricsScreen
  rts

eraseScreen0:
  lda #0
erase0low:
  ldy #1
  sta $efff,y
  sta $efff+(167*1),y
  sta $efff+(167*2),y
  sta $efff+(167*3),y
  sta $efff+(167*4),y
  sta $efff+(167*5),y
  dec erase0low+1
  bne rrr
  lda #167
  sta erase0low+1
rrr:
  rts
  
eraseScreen1:
  lda #0
erase1low:
  ldy #1
  sta $f3ff,y
  sta $f3ff+(167*1),y
  sta $f3ff+(167*2),y
  sta $f3ff+(167*3),y
  sta $f3ff+(167*4),y
  sta $f3ff+(167*5),y
  dec erase1low+1
  bne rrr2
  lda #167
  sta erase1low+1
rrr2:
  rts



;BEWARE! Not allowed to use x-register here below:  
doLyrics:
  dec lyricsWait
eraseBranch:
  bne eraseScreen0
  lda lyricsScreen
  sta $d018
nextEraseBranch:
  lda #eraseScreen0-eraseBranch-2
  sta eraseBranch+1
  lda #3
  sta lyricsWait
  ldy #0
  lda (lyricsPoi),y
  bpl normal
  cmp #$ff
  bne notWaii
  iny
  lda (lyricsPoi),y
  sta lyricsWait
  iny
  lda (lyricsPoi),y
  sta lyricsScreen
  iny
  lda (lyricsPoi),y
  sta nextEraseBranch+1
  lda lyricsPoi
  clc
  adc #4
  sta lyricsPoi
  lda lyricsPoi+1
  adc #0
  sta lyricsPoi+1
  rts
notWaii:
  iny
  lda (lyricsPoi),y
  sta screenPoi
  iny
  lda (lyricsPoi),y
  beq endLyr
  sta screenPoi+1
  lda lyricsPoi
  clc
  adc #3
  sta lyricsPoi
  lda lyricsPoi+1
  adc #0
  sta lyricsPoi+1
  rts
normal:
  and #$3f
  sta (screenPoi),y
  ora #$40
  inc screenPoi
  bne noPa2
  inc screenPoi+1
noPa2:
  sta (screenPoi),y
  ora #$80
  ldy #40
  sta (screenPoi),y
  and #$bf
  dey
  sta (screenPoi),y
  inc lyricsPoi
  bne noPa
  inc lyricsPoi+1
noPa:  
  inc screenPoi
  bne noPa3
  inc screenPoi+1
noPa3:
  rts

endLyr:
  lda #$7F   ;Set NMI mask to 0 for all NMIs
  sta $DC0D  ;CIA Interrupt Control Register (Read NMls/Write Mask)
  sta $DD0D  ;CIA Interrupt Control Register (Read NMls/Write Mask)
  lda $DC0D  ;Clear all pending NMI flags
  lda $DD0D  ;Clear all pending NMI flags
  lda #$10   ;Force load Timer A, system02clk, continuous, stop
  sta $DC0E  ;CIA Control Register A
  sta $DD0E  ;CIA Control Register A
  sta $DC0F  ;CIA Control Register B, stop
  sta $DD0F  ;CIA Control Register B, stop
  lda #$0c  ;Let all NMI's jump to an rti at $dd0c that reads (=clears) $dd0d
  sta $fffa
  lda #$dd
  sta $fffb
  lda #96        ;=rts
  sta doLyrics  ;disable lyrics
  lda #2        ;Let the border be red when finishing
  sta $d020
  sta idleColor+1
  lda #$80
  sta $d40b
  sta $d412
  lda #$00
  sta $d404
  lda #<IRQEND2
  sta $FFFE  ;IRQ low
  lda #>IRQEND2
  sta $FFFF  ;IRQ high
;It's time to make the CPU break out of the RenderLoop
  brk
  pla
  pla
  pla
  pla
  pla
  cli
thisIsTheEnd:          ;capture the CPU in this loop, and let IRQEND2 do the tricks...
  jmp thisIsTheEnd  



  .RES $c000-*,$00
volumeTable:
;Free space from d000-dfff, but cannot use it since we don't have time
;to switch out the VIC/SID bank

  .RES $e000-*,$00
  .incbin     "2x2_charset"   ;A complete charset is $0800 long.
;Free space from e800-fbff

Lyrics:
  .byte $80
  .word (screen1+0*40+12)
  SCREEN "I AM SIDDING"
  .byte $80
  .word (screen1+3*40+11)
  SCREEN "IN THE MORNING"
  .byte $80
  .word (screen1+6*40+10)
  SCREEN "AT THE DINER"
  .byte $80
  .word (screen1+9*40+9)
  SCREEN "ON THE CORNER"

  .byte $80
  .word (screen1+14*40+4)
  SCREEN "I AM WAITING"
  .byte $80
  .word (screen1+17*40+3)
  SCREEN "AT THE COUNTER"
  .byte $80
  .word (screen1+20*40+2)
  SCREEN "FOR THE MAN"
  .byte $80
  .word (screen1+23*40+1)
  SCREEN "TO POUR THE COFFEE"

  .byte $ff,$80,$c8,eraseScreen1-eraseBranch-2 ;Wait a little, goto screen0


  .byte $80
  .word (screen0+0*40+1)
  SCREEN "AND HE FILLS IT"
  .byte $80
  .word (screen0+3*40+2)
  SCREEN "ONLY HALFWAY"
  .byte $80
  .word (screen0+6*40+3)
  SCREEN "AND BEFORE"
  .byte $80
  .word (screen0+9*40+4)
  SCREEN "I EVEN ARGUE"

  .byte $80
  .word (screen0+14*40+4)
  SCREEN "HE IS YADA YADA"
  .byte $80
  .word (screen0+17*40+3)
  SCREEN "BING BING YADA"
  .byte $80
  .word (screen0+20*40+2)
  SCREEN "YADA HEY YADA..."
  .byte $80
  .word (screen0+23*40+1)
  SCREEN "KNOW WHAT I MEAN..."

  .byte $ff,$60,$d8,eraseScreen0-eraseBranch-2 ;Wait a little, goto screen1


  .byte $80
  .word (screen1+0*40+1)
  SCREEN "WHAT"
  .byte $80
  .word (screen1+0*40+10)
  SCREEN "IS"
  .byte $80
  .word (screen1+0*40+15)
  SCREEN "THIS"
  .byte $80
  .word (screen1+0*40+24)
  SCREEN "REALLY?"
  .byte $80
  .word (screen1+6*40+10)
  SCREEN "MP3 ON C64"

  .byte $80
  .word (screen1+14*40+28)
  SCREEN "?"
  .byte $80
  .word (screen1+22*40+25)
  SCREEN "HAHA"

  .byte $ff,$90,$c8,eraseScreen1-eraseBranch-2 ;Wait a little, goto screen0

  .byte $80
  .word (screen0+0*40+5)
  SCREEN "MAHONEY PROUDLY"
  .byte $80
  .word (screen0+3*40+12)
  SCREEN "PRESENTS"
  .byte $80
  .word (screen0+9*40+8)
  SCREEN "SUZANNE VEGA"
  .byte $80
  .word (screen0+12*40+9)
  SCREEN "TOM'S DINER"

  .byte $80
  .word (screen0+17*40+3)
  SCREEN "THE WORLD'S FIRST"
  .byte $80
  .word (screen0+20*40+9)
  SCREEN "MP3-DECODER"
  .byte $80
  .word (screen0+23*40+5)
  SCREEN "ON COMMODORE 64"


  .byte $ff,$90,$d8,eraseScreen0-eraseBranch-2 ;Wait a little, goto screen1

  .byte $80
  .word (screen1+0*40+12)
  SCREEN "CD  MP3 C64MP3"
  .byte $80
  .word (screen1+8*40+0)
;CD uses 44100*32 bits per second
;MP3 uses ~256kbits per second
;SP3 uses 40kB for a song. Tom's Diner is 2m8s long = 128 seconds.  
;40*1024 / (2*60+8) = 320 bits per second
  SCREEN "RATIO 1:1 1:6 1:4400"
  .byte $80
  .word (screen1+14*40+1)
  SCREEN "BW    22   20 16KHZ"

  .byte $80
  .word (screen1+5*40+1)
  SCREEN "SNR   96   96  26DB"

  .byte $80
  .word (screen1+23*40+11)
  SCREEN "1982 1991 2010"

  .byte $80
  .word (screen1+17*40+1)
  SCREEN "RETRO NO   NO  YES!"

  .byte $80
  .word (screen1+11*40+1)
  SCREEN "FREE  NO   NO  YES!"
  .byte $80
  .word (screen1+20*40+1)
  SCREEN "FUN   NO   NO  YES!"



  .byte $ff,$90,$c8,eraseScreen1-eraseBranch-2 ;Wait a little, goto screen0


  .byte $80
  .word (screen0+5*40+1)
  SCREEN "GETTING ALL"
  .byte $80
  .word (screen0+7*40+19)
  SCREEN "THE GIRLS?"
  .byte $ff,$20,$c8,eraseScreen1-eraseBranch-2 ;Wait a little, goto screen0
  .byte $80
  .word (screen0+12*40+3)
  SCREEN "CD: IN 1985, YES"
  .byte $ff,$20,$c8,eraseScreen1-eraseBranch-2 ;Wait a little, goto screen0
  .byte $80
  .word (screen0+17*40+3)
  SCREEN "MP3: IN 1993, YES"
  .byte $ff,$20,$c8,eraseScreen1-eraseBranch-2 ;Wait a little, goto screen0
  .byte $80
  .word (screen0+22*40+3)
  SCREEN "C64MP3: NEVER"



  .byte $ff,$86,$d8,eraseScreen0-eraseBranch-2 ;Wait a little, goto screen1
  .byte $80
  .word (screen1+0*40+11)
  SCREEN "C64MP3 USES:"
  .byte $80
  .word (screen1+3*40+3)
  SCREEN "15 OPCODES/SAMPLE"
  .byte $80
  .word (screen1+5*40+4)
  SCREEN "A WRAPPING STACK"
  .byte $80
  .word (screen1+7*40+5)
  SCREEN "NMI IRQ AT DD04"
  .byte $80
  .word (screen1+9*40+8)
  SCREEN "SID TEST BIT"
  .byte $80
  .word (screen1+11*40+7)
  SCREEN "8-BIT OUTPUT"
  .byte $80
  .word (screen1+13*40+5)
  SCREEN "JMP DD0C AS rti"
  .byte $80
  .word (screen1+15*40+5)
  SCREEN "NO PITCH TABLES"
  .byte $80
  .word (screen1+17*40+4)
  SCREEN "DITHERING NOISE"
  .byte $80
  .word (screen1+19*40+4)
  SCREEN "INTERPOLATION"
  .byte $80
  .word (screen1+21*40+1)
  SCREEN "PHASE-ALIGNED WAVES"
  .byte $80
  .word (screen1+23*40+4)
  SCREEN "ALL SID VOICES"

  .byte $ff,$96,$c8,eraseScreen1-eraseBranch-2 ;Wait a little, goto screen0

  .byte $80
  .word (screen0+0*40+4)
  SCREEN "FULL SOURCE CODE"
  .byte $80
  .word (screen0+3*40+1)
  SCREEN "ENCODER AND DECODER"
  .byte $80
  .word (screen0+11*40+19)
  SCREEN "AT"
  .byte $80
  .word (screen0+14*40+5)
  SCREEN "MAHONEY.C64.ORG"

  .byte $ff,$60,$d8,eraseScreen0-eraseBranch-2 ;Wait a little, goto screen1

  .byte $80
  .word (screen1+9*40+9)
  SCREEN "RELEASED AT"
  .byte $80
  .word (screen1+12*40+6)
  SCREEN "DATASTORM 2010"

  .byte $ff,$80,$c8,eraseScreen1-eraseBranch-2 ;Wait a little, goto screen0
  .byte $80
  .word (screen0+0*40+1)
  SCREEN "GREETINGS:"
  .byte $80
  .word (screen0+3*40+4)
  SCREEN "ZIPHOID  BLAIZER"
  .byte $80
  .word (screen0+5*40+5)
  SCREEN "JACKASSER  FNORD"
  .byte $80
  .word (screen0+7*40+4)
  SCREEN "FIREFOX  SLAYGON"
  .byte $80
  .word (screen0+9*40+5)
  SCREEN "SCENESAT  KAKTUS"
  .byte $80
  .word (screen0+11*40+4)
  SCREEN "MAKKE  SOUNDEMON"
  .byte $80
  .word (screen0+13*40+1)
  SCREEN "THCM  MIXER  MELINA"
  .byte $80
  .word (screen0+15*40+4)
  SCREEN "REYN  ROB HUBBARD"
  .byte $80
  .word (screen0+17*40+5)
  SCREEN "LMAN  ERWIK  DHS"
  .byte $80
  .word (screen0+19*40+4)
  SCREEN "LINUS WALLEIJ"
  .byte $80
  .word (screen0+21*40+4)
  SCREEN "MARCEL DONNE"
  .byte $80
  .word (screen0+23*40+5)
  SCREEN "ERIK PERSSON"

  .byte $80
  .word (screen0+3*40+4)
  SCREEN "                "
  .byte $80
  .word (screen0+3*40+4)
  SCREEN "TRIAD"
  .byte $80
  .word (screen0+5*40+5)
  SCREEN "                "
  .byte $80
  .word (screen0+5*40+5)
  SCREEN "FAIRLIGHT"
  .byte $80
  .word (screen0+7*40+4)
  SCREEN "                "
  .byte $80
  .word (screen0+7*40+4)
  SCREEN "PLUSH"
  .byte $80
  .word (screen0+9*40+5)
  SCREEN "                "
  .byte $80
  .word (screen0+9*40+5)
  SCREEN "INSTINCT"
  .byte $80
  .word (screen0+11*40+4)
  SCREEN "                "
  .byte $80
  .word (screen0+11*40+4)
  SCREEN "HT"
  .byte $80
  .word (screen0+13*40+1)
  SCREEN "                   "
  .byte $80
  .word (screen0+13*40+5)
  SCREEN "MANIACS OF NOISE"
  .byte $80
  .word (screen0+15*40+4)
  SCREEN "                 "
  .byte $80
  .word (screen0+17*40+5)
  SCREEN "                "
  .byte $80
  .word (screen0+19*40+4)
  SCREEN "             "
  .byte $80
  .word (screen0+21*40+4)
  SCREEN "            "
  .byte $80
  .word (screen0+23*40+5)
  SCREEN "            "
  .byte $80
  .word (screen0+19*40+4)
  SCREEN "YOU NEVER FAIL"
  .byte $80
  .word (screen0+21*40+5)
  SCREEN "TO IMPRESS ME"
  .byte $80
  .word (screen0+23*40+4)
  SCREEN "AND INSPIRE ME"



  .byte $ff,$70,$d8,eraseScreen0-eraseBranch-2 ;Wait a little, goto screen1
  .byte $80
  .word (screen1+7*40+3)
  SCREEN "...I FINISH UP"
  .byte $80
  .word (screen1+10*40+12)
 SCREEN "MY COFFEE"
  .byte $80
  .word (screen1+13*40+3)
  SCREEN "IT'S TIME TO"
  .byte $80
  .word (screen1+16*40+8)
  SCREEN "CATCH THE TRAIN"

  .byte $ff,$60,$c8,eraseScreen1-eraseBranch-2 ;Wait a little, goto screen0
  .byte $80
  .word (screen0+0*40+1)
  SCREEN "DU DU DU DU DUTUDU"
  .byte $80
  .word (screen0+3*40+35)
  SCREEN "DU"
  .byte $80
  .word (screen0+9*40+17)
 SCREEN "---"
  .byte $80
  .word (screen0+12*40+4)
 SCREEN "RIKTIG VALFRIHET"
  .byte $80
  .word (screen0+14*40+2)
 SCREEN "FINNS BARA I HAVET"
  .byte $80
  .word (screen0+17*40+17)
 SCREEN "---"
  .byte $80
  .word (screen0+21*40+2)
 SCREEN "PEX"
  .byte $80
  .word (screen0+22*40+7)
 SCREEN "MAHONEY"
  .byte $80
  .word (screen0+23*40+20)
 SCREEN "TUFVESSON"
  .byte $80
  .word (screen0+21*40+30)
 SCREEN "2010"
  .byte $80
  .word (screen0+0*40+1)
; SCREEN "DU DU DU DU DUTUDU"
; SCREEN "MP3 ON C64? YOU BET"
  SCREEN "HAVE A NOISE NIGHT!"
  .byte $80
  .word (screen0+3*40+35)
  SCREEN "  "
  .byte $ff,$3a,$c8,eraseScreen1-eraseBranch-2 ;Wait a little, goto screen0

  .byte $80,$00  ;End


  .RES $ef00-*,$00
theLsrTable:
  .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
  .byte $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
  .byte $02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02
  .byte $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03
  .byte $04,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04
  .byte $05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05
  .byte $06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06
  .byte $07,$07,$07,$07,$07,$07,$07,$07,$07,$07,$07,$07,$07,$07,$07,$07
  .byte $08,$08,$08,$08,$08,$08,$08,$08,$08,$08,$08,$08,$08,$08,$08,$08
  .byte $09,$09,$09,$09,$09,$09,$09,$09,$09,$09,$09,$09,$09,$09,$09,$09
  .byte $0a,$0a,$0a,$0a,$0a,$0a,$0a,$0a,$0a,$0a,$0a,$0a,$0a,$0a,$0a,$0a
  .byte $0b,$0b,$0b,$0b,$0b,$0b,$0b,$0b,$0b,$0b,$0b,$0b,$0b,$0b,$0b,$0b
  .byte $0c,$0c,$0c,$0c,$0c,$0c,$0c,$0c,$0c,$0c,$0c,$0c,$0c,$0c,$0c,$0c
  .byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
  .byte $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
  .byte $0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f

  .RES $f000-*,$00
screen0:
  .RES $f400-*,$00  ;Clear screen to begin with...
screen1:
  .RES $f800-*,$00  ;Clear screen to begin with...

;  .include "man_with_hat.s" ;A charset image, 16 chars wide, 12 chars high
  .incbin "man_with_hat_inv.bin" ;A charset image, 16 chars wide, 12 chars high


  .RES $fe00-*,$00
  .byte %00000000,%00000000,%00000000
  .byte %00000000,%00000000,%00000000
  .byte %00000000,%00000000,%00000000
  .byte %00000000,%00000000,%00000000
  .byte %00000000,%00000000,%00000000
  .byte %00000000,%00000000,%00000000
  .byte %00000000,%00000000,%00000000
  .byte %00000000,%00000000,%00000000
  .byte %00000000,%00000000,%00000000
  .byte %00000000,%00000000,%00000000
  .byte %00000000,%00000000,%00000000
  .byte %00000000,%00000000,%00000000
  .byte %00000000,%00000000,%00000000
  .byte %00000000,%00000000,%00000000
  .byte %00000000,%00000000,%00000000
  .byte %00000000,%00000000,%00000000
  .byte %00000000,%00000000,%00000000
  .byte %00101000,%00000000,%00000000
  .byte %00010000,%00000000,%00000000
  .byte %01000100,%00000000,%00000000
  .byte %00111000,%00000000,%00000000



;The "Mother of the MP3"
;
;An article in the now defunct magazine Business 2.0 revealed that "Tom's Diner" was also ;used by Karlheinz Brandenburg to develop the audio compression scheme known as MP3 at what ;is now the Fraunhofer Society. He recalled:
;
    ;I was ready to fine-tune my compression algorithm...somewhere down the corridor, a
    ;radio was playing "Tom's Diner". I was electrified. I knew it would be nearly
    ;impossible to compress this warm a cappella voice.[4]
;
;Brandenburg adopted the song for testing purposes, listening to it again and again each ;time he refined the scheme, making sure it did not adversely affect the subtlety of Vega's ;voice. While it is an exaggeration to say that the MP3 compression format is specifically ;tuned to play the song "Tom's Diner" (an assortment of critically analyzed material was ;involved in the design of the codec over many years), among some audio engineers this ;anecdote has earned Vega the informal title "The Mother of the MP3".




;Tom's Diner by Suzanne Vega, lyrics:
;I am sitting
;In the morning
;At the diner
;On the corner
;
;I am waiting
;At the counter
;For the man
;To pour the coffee
;
;And he fills it
;Only halfway
;And before
;I even argue
;
;He is looking
;Out the window
;At somebody
;Coming in
;
;"It is always
;Nice to see you"
;Says the man
;Behind the counter
;
;To the woman
;Who has come in
;She is shaking
;Her umbrella
;
;And I look
;The other way
;As they are kissing
;Their hellos
;
;I'm pretending
;Not to see them
;Instead
;I pour the milk
;
;I open
;Up the paper
;There's a story
;Of an actor
;
;Who had died
;While he was drinking
;It was no one
;I had heard of
;
;And I'm turning
;To the horoscope
;And looking
;For the funnies
;
;When I'm feeling
;Someone watching me
;And so
;I raise my head
;
;There's a woman
;On the outside
;Looking inside
;Does she see me?
;
;No she does not
;Really see me
;Cause she sees
;Her own reflection
;
;And I'm trying
;Not to notice
;That she's hitching
;Up her skirt
;
;And while she's
;Straightening her stockings
;Her hair
;Has gotten wet
;
;Oh, this rain
;It will continue
;Through the morning
;As I'm listening
;
;To the bells
;Of the cathedral
;I am thinking
;Of your voice...
;
;And of the midnight picnic
;Once upon a time
;Before the rain began...
;
;I finish up my coffee
;It's time to catch the train
;
